local MAP = "MAPNP"
local wariochallenge = false

local RESTORE_TIME = 215*TICRATE

local CV_TO_CHANGE = {
    {cvname="triplesneaker", value="off"},
    {cvname="sneaker", value= "off"},
    {cvname="grow", value= "off"},
    {cvname="invincibility", value= "off"},
    {cvname="rocketsneaker", value= "off"}
}

local CV_Backups= nil

local function backupAndChangeCV()
	if not isserver then return end

    if not CV_Backups then
        CV_Backups= {}
    end

    for i=1,#CV_TO_CHANGE do
        local obj= CV_TO_CHANGE[i]
        local cv= CV_FindVar(obj.cvname)
        if not cv then
            print("ERROR - Counldn't access CVar '"..obj.cvname.."'...")
            continue
        end

        CV_Backups[obj.cvname]= cv.value

		CV_Set(cv, obj.value)
    end
end

local function restoreCV()
	if not isserver then return end

    if not CV_Backups then return end

    for cvname,value in pairs(CV_Backups) do
        local cv= CV_FindVar(cvname)
        if not cv then
            print("ERROR - Counldn't restore CVar '"..cvname.."'...")
            continue
        end

		CV_Set(cv, value)
    end

    CV_Backups= nil
end

addHook("MapLoad", function(mapid)
    wariochallenge = G_BuildMapName(mapid) == MAP
end)

addHook("NetVars", function(net)
    wariochallenge = net($)
end)

addHook("ThinkFrame", function()
    if leveltime == 1 then
        restoreCV()
    end
    
    if wariochallenge then
        if leveltime == 4 then
            backupAndChangeCV()
        end
        
        if leveltime == RESTORE_TIME then
            restoreCV()
            G_ExitLevel()
        end
    end
end)

addHook("IntermissionThinker", restoreCV)
addHook("VoteThinker", restoreCV)